import{Type as t}from"@freik/core-utils"
import r from"minimist"
import e from"path"
import{EnumerateBoards as o}from"./board.js"
import{IsConfigPresent as a,ReadConfig as i}from"./config.js"
import{Dump as n,FlushOutput as s,SetOutputFile as m}from"./dump.js"
import{MakeGlobals as f}from"./globals.js"
import{GetLibraries as l}from"./libraries.js"
import{ParseFile as g}from"./parser.js"
import{MakePlatform as p}from"./platform.js"
import{GetGnuMakeTarget as c}from"./targets/gnumake.js"
export function ShowHelp(r){t.isUndefined(r)||((t.isString(r)?[r]:r).forEach(n("err")),n("err")("")),n("err")("\nUsage: {flags} rootDir {lib1Dir lib2Dir lib3Dir}\n  rootDir is where you can find 'boards.txt' and 'platform.txt'\n  flags:\n    --config|-c <file.json> Read the config from the json file\n    --out|-o <filename> Spit the output into filename\n    --target|-t <gnumake> Generate a project for the given target (only GNUMake currently...)\n"),process.exit(0)}const u=c()
export function GetTarget(){return u}export default async function h(...n){try{const c=await async function(e){const o=r(e,{string:["config","target","out","help"],alias:{c:"config",t:"target",o:"out",h:"help","?":"help"},default:{target:"gnumake"}})
if(t.hasStr(o,"help")&&ShowHelp(),t.hasStr(o,"config")&&await i(o.config),m(o?.out),t.hasStr(o,"target")&&"gnumake"!==o.target.toLocaleLowerCase())throw Error(`Command line error: Unsupported target ${o.target}`)
return o._}(n)
0!==c.length||a()||ShowHelp("Missing command line or configuration")
const h=c[0],w=c.slice(1),d=o(await g(e.join(h,"boards.txt"))),j=e.join(h,"platform.txt"),b=await g(j),S=(p(b),await l(h,w))
f(u),await u.emit(j,b,d,S),await s()}catch(r){const e=t.hasStr(r,"name")?r.name:"<unknown>",o=t.hasStr(r,"message")?r.message:"<no message>"
ShowHelp(`Error: ${e} @ ${t.hasStr(r,"fileName")?r.fileName:"<no filename>"}#${t.has(r,"lineNumber")&&t.isNumber(r.lineNumber)?r.lineNumber:-1}:\n${o}`)}}