import{Type as e}from"@freik/core-utils"
import*as n from"path"
import{GetFileList as s}from"../files.js"
import{GetNestedChild as t}from"../symbols.js"
import{GetPlainValue as o,QuoteIfNeeded as r,Unquote as p}from"../utils.js"
import{GetLibDefs as c}from"./gmLibs.js"
import{MakePrefixer as _}from"./gmPrefixer.js"
import{MakeAppend as a,MakeDeclDef as S,MakeDefinitions as l,MakeIfeq as i,MakeSeqDef as u,MakeSrcList as d,MakeUnDecl as R}from"./gmUtils.js"
export async function BuildPlatform(h,f,$,E,O){const A=[S("BUILD_CORE_PATH","${RUNTIME_PLATFORM_PATH}/cores/${BUILD_CORE}",["RUNTIME_PLATFORM_PATH","BUILD_CORE"])],C={name:"fake",children:$.scopedTable},m=o,I=l(C,m,null,(e=>"recipe"!==e.name&&"tools"!==e.name)),U=l(C,m,null,(function(e){for(;e.parent;e=e.parent)if("tools"===e.name)return!0
return"tools"===e.name})),L=U.filter((e=>e.name.endsWith("_CMD"))),T=U.filter((e=>e.name.endsWith("_MACOSX"))),P=U.filter((e=>e.name.endsWith("_WINDOWS"))),D=i("${RUNTIME_OS}","macosx"),B=[]
for(const e of T){const n=e.name.substring(0,e.name.lastIndexOf("_MACOSX"))
B.push(S(n,e.value,e.dependsOn,[D]))}const v=i("${RUNTIME_OS}","windows")
for(const e of P){const n=e.name.substring(0,e.name.lastIndexOf("_WINDOWS"))
B.push(S(n,e.value,e.dependsOn,[v]))}B.push(...L.map((e=>R(e.name,e.value,e.dependsOn))))
const N=$.scopedTable.get("tools")
if(N)for(const[e,n]of N.children){const s=t(n,"upload","pattern")
if(!s)continue
const r=i("${UPLOAD_USE_1200BPS_TOUCH}","true"),p=S("UPLOAD_EXTRA_FLAGS","--touch 1200",[],[r])
B.push(p)
const c=i("${UPLOAD_TOOL}",e),_=o(s),a=_.value.replace("${CMD}","${TOOLS_"+e.toUpperCase()+"_CMD}")
_.unresolved.delete("CMD")
const l=S("UPLOAD_PATTERN",a.replace("${BUILD_PATH}","$(abspath ${BUILD_PATH})"),[..._.unresolved,p.name],[c])
B.push(l)}const g=$.scopedTable.get("recipe")
if(g?.children.has("cpp")){const n=g.children.get("cpp"),s=n.children.get("o")
if(s&&1===n.children.size){const t=s.children.get("pattern")
if(t&&1===s.children.size&&t.value){const s=t.value
if(!e.isString(s))throw new Error("cpp patterns must be strings, not functions")
const o=s.indexOf(' "{source_file}" -o ')
if(o>0){const e=s.substring(0,o)+" -x c++"+s.substring(o),t={name:"ino",parent:n.parent,children:new Map},r={name:"o",children:new Map,parent:t},p={name:"pattern",parent:r,value:e,children:new Map}
r.children.set("pattern",p),t.children.set("o",r),g.children.set("ino",t)}}}}const H=g?function(e){function n(...n){const s=t(e,...n)
if(s){const e=o(s)
if(e.value.length>0)return e}}function s(e,s,t){const o=n(...e)
if(!o||!o.unresolved.has(t)||!o.unresolved.has(s))return
const r=o.value.replace("${"+t+"}","$<").replace("${"+s+"}","$@")
return o.unresolved.delete(s),o.unresolved.delete(t),{value:r,unresolved:o.unresolved}}const r=[]
for(const e of["S","c","ino","cpp"]){const n=s([e,"o","pattern"],"OBJECT_FILE","SOURCE_FILE")
if(!n)continue
const t=[...n.unresolved],o=n.value.split(" ").map((e=>{if("${INCLUDES}"===e)return"${SYS_INCLUDES} ${USER_INCLUDES}"
const n=e.indexOf('"'),s=e.lastIndexOf('"')
if(n<0&&s<0)return e
if(0===n&&s===e.length-1&&e.indexOf('"',1)===s)return e
const t=e.indexOf("'"),o=e.lastIndexOf("'")
return 0===t&&o===e.length-1&&e.indexOf("'",1)===o?e:`'${e}'`})).join(" ")
r.push({src:e,dst:"o",command:o,dependsOn:t})}const p=s(["ar","pattern"],"ARCHIVE_FILE_PATH","OBJECT_FILE")
if(p){const e=[...p.unresolved]
r.push({src:"o",dst:"a",command:p.value.replace('"$<"',"$^"),dependsOn:e})}const c=n("c","combine","pattern")
if(c){const{value:e,unresolved:n}=c
n.delete("OBJECT_FILES"),n.delete("ARCHIVE_FILE")
const s=e.replace("${OBJECT_FILES}","${USER_OBJS}").replace("${BUILD_PATH}/${BUILD_PROJECT_NAME}.elf","$@").replace("${ARCHIVE_FILE}","system.a")
r.push({src:"o-a",dst:"elf",command:s,dependsOn:[...n]})}const _=n("objcopy","hex","pattern")
if(_){const{value:e,unresolved:n}=_,s=e.replace("${BUILD_PATH}/${BUILD_PROJECT_NAME}.elf","$<").replace("${BUILD_PATH}/${BUILD_PROJECT_NAME}.hex","$@")
r.push({src:"elf",dst:"hex",command:s,dependsOn:[...n]})}const a=n("objcopy","zip","pattern")
if(a){const{value:e,unresolved:n}=a,s=e.replace("${BUILD_PATH}/${BUILD_PROJECT_NAME}.hex","$<").replace("${BUILD_PATH}/${BUILD_PROJECT_NAME}.zip","$@")
r.push({src:"hex",dst:"zip",command:s,dependsOn:[...n]}),r.push({src:"zip",dst:"flash",command:"${UPLOAD_PATTERN} ${UPLOAD_EXTRA_FLAGS}",dependsOn:[]})}else _&&r.push({src:"hex",dst:"flash",command:"${UPLOAD_PATTERN} ${UPLOAD_EXTRA_FLAGS}",dependsOn:[]})
return r}(g):[],M=new Set(f.filter((e=>"BUILD_CORE"===e.name)).map((e=>e.value))),x=new Set(f.filter((e=>"BUILD_VARIANT"===e.name)).map((e=>e.value))),Y=[],b=_([[h.find((e=>"RUNTIME_PLATFORM_PATH"===e.name))?.value||"!@#$","${RUNTIME_PLATFORM_PATH}"]])
for(const e of M){const{c:t,cpp:o,s:c,paths:_}=await s(n.join(p(E),"cores",e)),S=[i("${BUILD_CORE}",e)]
t.length&&Y.push(d("C_SYS_SRCS",t,"BUILD_CORE",S,b)),o.length&&Y.push(d("CPP_SYS_SRCS",o,"BUILD_CORE",S,b)),c.length&&Y.push(d("S_SYS_SRCS",c,"BUILD_CORE",S,b)),Y.push(a("SYS_INCLUDES"," "+r(`-I${b(n.join(p(E),"cores",e).replaceAll("\\","/"))}`),["BUILD_CORE"],S))
const l=_.map(r).map(b).join(" ")
l.length>0&&Y.push(a("VPATH_CORE",l,["BUILD_CORE"],S))}for(const e of x){const{c:t,cpp:o,s:c,paths:_,inc:S}=await s(n.join(p(E),"variants",e)),l=[i("${BUILD_VARIANT}",e)]
t.length&&Y.push(d("C_SYS_SRCS",t,"BUILD_VARIANT",l,b)),o.length&&Y.push(d("CPP_SYS_SRCS",o,"BUILD_VARIANT",l,b)),c.length&&Y.push(d("S_SYS_SRCS",c,"BUILD_VARIANT",l,b)),Y.push(d("SYS_INCLUDES",S,"BUILD_VARIANT",l,b,"-I"))
const u=_.map(r).map(b).join(" ")
u.length>0&&Y.push(a("VPATH_CORE",u,["BUILD_VARIANT"],l))}O.forEach((e=>{Y.push(...c(e,b))})),Y.push(S("SYS_SRC","${C_SYS_SRCS} ${CPP_SYS_SRCS} ${S_SYS_SRCS}")),Y.push(S("USER_SRC","${USER_C_SRCS} ${USER_CPP_SRCS} ${USER_S_SRCS}")),Y.push(S("ALL_SRC","${SYS_SRC} ${USER_SRC}")),Y.push(u("VPATH","${VPATH}:${VPATH_MORE}:${VPATH_CORE}:${VPATH_VAR}"))
const V=(e,n,s)=>S(e,`\\\n  $(addprefix \${BUILD_PATH}/, \\\n    $(patsubst %.c, %.c.${s}, \\\n      $(patsubst %.cpp, %.cpp.${s}, \\\n        $(patsubst %.ino, %.ino.${s}, \\\n          $(patsubst %.S, %.S.${s}, $(notdir \${${n}}))))))`,[],[])
return Y.push(V("SYS_OBJS","SYS_SRC","o")),Y.push(V("USER_OBJS","USER_SRC","o")),Y.push(S("ALL_OBJS","${USER_OBJS} ${SYS_OBJS}")),Y.push(V("SYS_JSN","SYS_SRC","jsn")),Y.push(V("USER_JSN","USER_SRC","jsn")),{defs:[...A,...I,...B,...Y],rules:H}}